## mingw-w64-elmerfem-26.1-1.src.tar.zst

=== CMakeLists.txt ===
#
# CMake configuration script for Elmer
#
# Authors:
#  Sami Ilvonen, CSC - IT Center for Science, Ltd.
#  Phil Weir, NUMA Engineering Services, Ltd.
#  Mikko Byckling, CSC - IT Center for Science Ltd.
#  Juhani Kataja, CSC - IT Center for Science Ltd.
#  Thomas Zwinger, CSC - IT Center for Science Ltd.
#
# First public beta release 11th of October, 2013
#

IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Build type (Release, Debug, RelWithDebugInfo, MinSizeRel)")
ENDIF()

CMAKE_MINIMUM_REQUIRED(VERSION 3.10)

if(POLICY CMP0074)
    cmake_policy(SET CMP0074 NEW)
endif()

PROJECT(Elmer Fortran C CXX)

IF(APPLE)
  SET(CMAKE_MACOSX_RPATH 1)
ENDIF()

# Allow users to ignore package managers on macOS
option(USE_MACOS_PACKAGE_MANAGER "Search for packages that are installed with Homebrew or MacPorts on macOS" ON)

#shamelessly borrowed from FreeCAD project: https://github.com/FreeCAD/FreeCAD/blob/master/cMake/FreeCAD_Helpers/SetupPython.cmake
# For building on OS X
if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin" AND USE_MACOS_PACKAGE_MANAGER)

  # If the user doesn't tell us which package manager they're using
  if(NOT DEFINED MACPORTS_PREFIX AND NOT DEFINED HOMEBREW_PREFIX)

    # Try to find MacPorts path
    find_program(MACPORTS_EXECUTABLE port)
    if(EXISTS ${MACPORTS_EXECUTABLE})
      string(REPLACE "/bin/port" ""
      MACPORTS_PREFIX ${MACPORTS_EXECUTABLE})
      message(STATUS "Detected MacPorts install at ${MACPORTS_PREFIX}")
    endif(EXISTS ${MACPORTS_EXECUTABLE})

    # Try to find Homebrew path
    find_program(HOMEBREW_EXECUTABLE brew)
    if(EXISTS ${HOMEBREW_EXECUTABLE})
      string(REPLACE "/bin/brew" ""
      HOMEBREW_PREFIX ${HOMEBREW_EXECUTABLE})
      message(STATUS "Detected Homebrew install at ${HOMEBREW_PREFIX}")
    endif()

  endif(NOT DEFINED MACPORTS_PREFIX AND NOT DEFINED HOMEBREW_PREFIX)

  # In case someone tries to shoot themselves in the foot
  if(DEFINED MACPORTS_PREFIX AND DEFINED HOMEBREW_PREFIX)
    message(SEND_ERROR "Multiple package management systems detected - ")
    message(SEND_ERROR "define either MACPORTS_PREFIX or HOMEBREW_PREFIX")

  # No package manager
  elseif(NOT DEFINED MACPORTS_PREFIX AND NOT DEFINED HOMEBREW_PREFIX)
    message(SEND_ERROR "No package manager detected - install MacPorts or Homebrew")
  endif()
endif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin" AND USE_MACOS_PACKAGE_MANAGER)
# endif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")


# SET(CMAKE_MODULE_PATH "${CMAKE_ROOT}/Modules;${PROJECT_SOURCE_DIR}/cmake/Modules")
SET(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/Modules;${CMAKE_ROOT}/Modules")

SET(CMAKE_Fortran_MODULE_DIRECTORY
  ${PROJECT_BINARY_DIR}/fmodules CACHE PATH "Directory for Fortran modules")

# Require minimum standard version
SET(CMAKE_C_STANDARD 99)
SET(CMAKE_C_STANDARD_REQUIRED ON)
SET(CMAKE_CXX_STANDARD 11)
SET(CMAKE_CXX_STANDARD_REQUIRED ON)

# Defaults to cache variables
SET(WITH_MPI TRUE CACHE BOOL "Use MPI parallelization")
SET(MPI_TEST_MAXPROC 8 CACHE STRING "Maximum number of tasks used in parallel tests")
SET(MPI_TEST_MINPROC 1 CACHE STRING "Minimum number of tasks used in parallel tests")
SET(WITH_OpenMP FALSE CACHE BOOL "Use OpenMP thread and SIMD (if available) parallelization")
SET(WITH_MKL FALSE CACHE BOOL "Use Intel Math Kernel library")
OPTION(HAVE_QP "Fortran compiler and runtime support quadruple-precision floating-point numbers" ON)
SET(WITH_Mumps FALSE CACHE BOOL "Use Mumps sparse direct solver")
SET(WITH_Hypre FALSE CACHE BOOL "Use Hypre linear algebra library")
SET(WITH_CHOLMOD FALSE CACHE BOOL "Use CHOLMOD linear algebra library")
SET(WITH_UMFPACK TRUE CACHE BOOL "Use UMFPACK for LU factorization")
SET(WITH_ELMERGUI FALSE CACHE BOOL "Include ElmerGUI")
SET(WITH_ElmerIce FALSE CACHE BOOL "Include ElmerIce")
SET(WITH_XIOS FALSE CACHE BOOL "Include XIOS")
SET(WITH_NETCDF FALSE CACHE BOOL "Include NetCDF")
SET(WITH_ELMERGUITESTER FALSE CACHE BOOL "Include ElmerGUI tester")
SET(WITH_ELMERGUILOGGER FALSE CACHE BOOL "Include ElmerGUI logger")
SET(ELMER_INSTALL_LIB_DIR "lib/elmersolver" CACHE PATH "Location of elmer shared libraries relative to prefix.")
SET(WITH_Trilinos FALSE CACHE BOOL "Use Trilinos")
SET(WITH_FETI4I FALSE CACHE BOOL "Use FETI4I")
SET(WITH_ELMERPOST FALSE CACHE BOOL "Include ElmerPost (DEPRECATED)")
SET(WITH_CONTRIB FALSE CACHE BOOL "Include contributed solvers")

SET(WITH_LUA FALSE CACHE BOOL "Include LUA extensions.")
SET(WITH_MMG FALSE CACHE BOOL "Compile with MMG library.")
SET(WITH_ROCALUTION FALSE CACHE BOOL "Compile with Rocalution library.")

SET(WITH_Zoltan FALSE CACHE BOOL "Link in Zoltan mesh repartitioning library.")
SET(USE_SYSTEM_ZOLTAN FALSE CACHE BOOL "Use system Zoltan library")

SET(INCLUDE_ELMER_MODULES "" CACHE STRING "Semicolon separated list of solver modules to be compiled. If empty compile all.")

# Let user select if the contiguous attribute is used or not
SET(USE_CONTIGUOUS FALSE CACHE BOOL "Use contiguous attribute")

MARK_AS_ADVANCED(WITH_ELMERPOST)

# if("${CMAKE_VERSION}" VERSION_GREATER 2.8.12)
#   CMAKE_POLICY(SET CMP0022 OLD)
# ENDIF()

OPTION (USE_NEW_POLICY_CMP0057 "Option to enable new policy CMP0057" ON)
IF (USE_NEW_POLICY_CMP0057)
  CMAKE_POLICY(SET CMP0057 NEW)
ENDIF()

MARK_AS_ADVANCED(ELMER_INSTALL_LIB_DIR)

INCLUDE(CTest)

SET(ELMER_FEM_MAJOR_VERSION 26)
SET(ELMER_FEM_MINOR_VERSION 1)

SET(ELMER_FEM_VERSION
  ${ELMER_FEM_MAJOR_VERSION}.${ELMER_FEM_MINOR_VERSION})

IF(NOT(ELMER_FEM_REVISION))
  SET(RESET_ELMER_REVISION TRUE CACHE BOOL "")
  MARK_AS_ADVANCED(RESET_ELMER_REVISION)
ENDIF()

IF(RESET_ELMER_REVISION)
  execute_process(
    COMMAND "git" "--no-pager" "log" "-1" "--pretty=format:%h"
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    OUTPUT_VARIABLE ELMER_FEM_REVISION_
    RESULT_VARIABLE RUN_RETURN_VALUE)
  IF(RUN_RETURN_VALUE EQUAL 0)
    SET(ELMER_FEM_REVISION ${ELMER_FEM_REVISION_} CACHE STRING "" FORCE)
    MARK_AS_ADVANCED(ELMER_FEM_REVISION)
  ENDIF()
ENDIF()

SET(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
STRING(TIMESTAMP ELMER_FEM_COMPILATIONDATE "%Y-%m-%d")
SET(COMPILATIONDATE ${ELMER_FEM_COMPILATIONDATE})

# Check that the gfortran version is >= 7
IF(${CMAKE_Fortran_COMPILER_ID} MATCHES "GNU")
  INCLUDE(testGFortranVersion)
  IF(NOT CMAKE_Fortran_COMPILER_GNU_VERSION_OK)
    MESSAGE(FATAL_ERROR "GNU Fortran major version is too old, should be at least 7")
  ENDIF()
ENDIF()

IF(WITH_LUA)
  IF(NOT(${USE_SYSTEM_LUA}))
    ADD_SUBDIRECTORY(${CMAKE_CURRENT_SOURCE_DIR}/contrib/lua-5.1.5/)
    set(LUA_LIBRARIES luaelmer CACHE STRING "")
    set(LUA_INCLUDE_DIR ${PROJECT_SOURCE_DIR}/contrib/lua-5.1.5/src CACHE STRING "")
  ELSE()
    FIND_PACKAGE(Lua51 REQUIRED)
  ENDIF()
  SET(HAVE_LUA TRUE)
  MARK_AS_ADVANCED(HAVE_LUA)
ENDIF()

IF(WITH_EXTOPTIM)
  SET(HAVE_EXTOPTIM TRUE)
ENDIF()

IF(WITH_OpenMP)
  FIND_PACKAGE(OpenMP REQUIRED)

  # FIXME: Should link to the CMake targets instead
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
  SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${OpenMP_Fortran_FLAGS}")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")

  # Set variables for supported OpenMP version
  IF(OpenMP_Fortran_VERSION VERSION_GREATER_EQUAL 4.0)
    SET(HAVE_OPENMP40 TRUE)
    MARK_AS_ADVANCED(HAVE_OPENMP40)
    IF(OpenMP_Fortran_VERSION VERSION_GREATER_EQUAL 4.5)
      SET(HAVE_OPENMP45 TRUE)
      MARK_AS_ADVANCED(HAVE_OPENMP45)
    ENDIF()
  ENDIF()
ENDIF()

# Get rid of the annoying rank mismatch warning
IF("${CMAKE_Fortran_COMPILER_ID}" MATCHES "GNU")
  IF(CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER 9.9)
    SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fallow-argument-mismatch")
#    SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -std=legacy")
  ENDIF()
ENDIF()


# Import targets with information for using MPI or the MPI stub
ADD_LIBRARY(Elmer::MPI_Fortran INTERFACE IMPORTED)
ADD_LIBRARY(Elmer::MPI_C INTERFACE IMPORTED)
ADD_LIBRARY(Elmer::MPI_CXX INTERFACE IMPORTED)
IF(WITH_MPI)
  # Advanced properties
  MARK_AS_ADVANCED(
    MPI_EXTRA_LIBRARY
    MPI_LIBRARY
    )

  FIND_PACKAGE(MPI REQUIRED)

  # Check features of found MPI
  INCLUDE(testMPIcapabilities)
  IF(ELMER_BROKEN_MPI_IN_PLACE)
    ADD_DEFINITIONS(-DELMER_BROKEN_MPI_IN_PLACE)
  ENDIF()

  TARGET_LINK_LIBRARIES(Elmer::MPI_Fortran INTERFACE MPI::MPI_Fortran)
  TARGET_LINK_LIBRARIES(Elmer::MPI_C INTERFACE MPI::MPI_C)
  TARGET_LINK_LIBRARIES(Elmer::MPI_CXX INTERFACE MPI::MPI_CXX)
ENDIF(WITH_MPI)


IF (WITH_ROCALUTION)

  IF(NOT WITH_MPI)
    MESSAGE(FATAL_ERROR "Building with rocALUTION requires MPI")
  ENDIF()

  MESSAGE(STATUS "------------------------------------------------")
  MESSAGE(STATUS "Looking for rocALUTION installation")

  FIND_PACKAGE(rocalution REQUIRED)

  MESSAGE(STATUS "  rocALUTION:     " "${rocalution_FOUND}")
  MESSAGE(STATUS "  rocALUTION_INC: " "${ROCALUTION_INCLUDE_DIR}")
  MESSAGE(STATUS "  rocALUTION_LIB: " "${ROCALUTION_LIBRARY}")

  SET(HAVE_ROCALUTION TRUE CACHE BOOL "")
  MARK_AS_ADVANCED(HAVE_ROCALUTION)
ENDIF()


IF(WITH_AMGX)
  FIND_PACKAGE(AMGX)
ENDIF()

IF(WITH_CHOLMOD)
  FIND_PACKAGE(CHOLMOD)
  FIND_PACKAGE(SPQR)
ENDIF()

# if(APPLE)
#   # message(STATUS "Trying to find Accelerate library")
#   # find_library(BLAS_LIBRARIES Accelerate HINTS /System/Library/Frameworks/Accelerate.framework)
#   # MARK_AS_ADVANCED(BLAS_LIBRARIES)
#   # set(BLAS_LINKER_FLAGS "${CMAKE_LINKER_FLAGS} -framework accelerate")
#   # find_path(LAPACK_INCLUDE_DIRS
#   #   NAMES clapack.h
#   #   PATHS ${BLAS_INCLUDE_DIRS}
#   #   NO_DEFAULT_PATH
#   # )
#   # set(LAPACK_HEADER ${LAPACK_INCLUDE_DIRS}/clapack.h)
#   # set(LAPACK_SUFFIX "_")
#   # set(LAPACK_PREFIX)

#   # message(STATUS "Using Accelerate framework on macOS")
#   message("using the local blas library")
#   # option(BLAS_VERBOSE "Print some additional information during BLAS libraries detection" ON)
#   set(BLAS_DIR "./mathlibs/src/blas/")
# set(BLA_VENDOR "Generic")

  # set(ACCELERATE_LIBS "-framework Accelerate")
  # BLAS_Accelerate_LIBRARY:FILEPATH=/System/Library/Frameworks/Accelerate.framework


# else()
  IF(WITH_MKL)
    # Find MKL
    FIND_PACKAGE(MKL REQUIRED)
    SET(HAVE_MKL TRUE)
    MARK_AS_ADVANCED(HAVE_MKL)
    # Set BLAS and LAPACK to point to MKL
    SET(BLAS_LIBRARIES ${MKL_BLAS_LIBRARIES} CACHE FILEPATH "")
    SET(LAPACK_LIBRARIES ${MKL_LAPACK_LIBRARIES} CACHE FILEPATH "")
    IF(MKL_SCALAPACK_LIBRARIES_FOUND)
      SET(SCALAPACK_LIBRARIES ${MKL_SCALAPACK_LIBRARIES})
      # Versions >11.1 of MKL include Cluster PARDISO direct solver
      IF(MKL_CPARDISO_FOUND)
        SET(HAVE_CPARDISO TRUE)
        MARK_AS_ADVANCED(HAVE_CPARDISO)
      ENDIF()
    ENDIF()
    INCLUDE_DIRECTORIES(${MKL_INCLUDE_DIR})
    SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${MKL_Fortran_FLAGS}")
  ELSE()
    IF (NOT BLAS_LIBRARIES OR NOT LAPACK_LIBRARIES)
      # If BLAS/LAPACK not explicitly set, attempt to find MKL BLAS/LAPACK
      FIND_PACKAGE(MKL QUIET)
      IF (MKL_BLAS_LIBRARIES_FOUND AND MKL_LAPACK_LIBRARIES_FOUND)
        # Set BLAS and LAPACK to point to MKL, in order to work around
        # CMake FindBLAS finding wrong core library for GNU Fortran
        SET(BLAS_LIBRARIES ${MKL_BLAS_LIBRARIES} CACHE FILEPATH "")
        SET(LAPACK_LIBRARIES ${MKL_LAPACK_LIBRARIES} CACHE FILEPATH "")
        INCLUDE_DIRECTORIES(${MKL_INCLUDE_DIR})
        SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${MKL_Fortran_FLAGS}")
      ENDIF()
    ENDIF()
  ENDIF()
# endif(APPLE)

# MARK_AS_ADVANCED(WITH_Trilinos)
IF(WITH_Trilinos)
  IF(NOT WITH_MPI)
    MESSAGE(FATAL_ERROR "Building with Trilinos requires MPI.")
  ENDIF()
  FIND_PACKAGE(ML REQUIRED PATHS ${TRILINOS_PATH}/lib/cmake/ML ${TRILINOS_PATH})
  FIND_PACKAGE(Trilinos REQUIRED PATHS ${TRILINOS_PATH}/lib/cmake/Trilinos ${TRILINOS_PATH})
  FIND_PACKAGE(Belos REQUIRED PATHS ${TRILINOS_PATH}/lib/cmake/Belos ${TRILINOS_PATH})
  IF(ML_DIR)
    ADD_DEFINITIONS(-DHAVE_TRILINOS)
  ENDIF()
ENDIF()

IF(WITH_Zoltan)
  # ZOLTAN Remeshing

=== ElmerGUI/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.10)
SET(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")
PROJECT(ElmerGUI CXX C)
SET(APPLICATION_INCLUDE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/netgen/libsrc/interface")

IF(APPLE)
include(cmake/Modules/FindOpenCasCade.cmake)
# add_subdirectory(cmake/Modules)
ENDIF()

SET(WITH_PYTHONQT FALSE CACHE BOOL "ElmerGUI: Use PythonQt for scripting in post processor?")
SET(WITH_OCC FALSE CACHE BOOL "ElmerGUI: Use OpenCASCADE for importing CAD files? Needs VTK.")
SET(WITH_MATC FALSE CACHE BOOL "ElmerGUI: Use MATC for internal operations in postprocessing?")
SET(WITH_PARAVIEW FALSE CACHE BOOL "ElmerGUI: Use ParaView for postprocessing?")
SET(WITH_VTK FALSE CACHE BOOL "ElmerGUI: Use VTK for postprocessing?")
SET(WITH_QWT TRUE CACHE BOOL "ElmerGUI: Use QWT for convergence monitor?")
SET(WITH_ELMERGUILOGGER FALSE CACHE BOOL "ElmerGUI: Include ElmerGUIlogger")

IF( NOT WITH_QT6)
  find_package(Qt5 COMPONENTS Widgets)
  if (Qt5_FOUND)
    set(WITH_QT5 TRUE CACHE BOOL "ElmerGUI: Use Qt5")
  endif()
ENDIF()

IF(WITH_QT6)
  MESSAGE(STATUS "------------------------------------------------")
  IF(WIN32)
    MESSAGE(STATUS "Qt6 Windows packaging")
    SET(QT6_PKG_LIST Qt6OpenGL Qt6OpenGLWidgets Qt6Qml Qt6Xml Qt6Gui Qt6Core Qt6Svg Qt6Widgets Qt6PrintSupport)
  ELSE()
    MESSAGE(STATUS "Qt6 non-Windows packaging")
    SET(QT6_PKG_LIST Qt6OpenGL Qt6Qml Qt6Xml Qt6Gui Qt6Core Qt6Svg Qt6PrintSupport Qt6OpenGLWidgets)
  ENDIF()
  FOREACH(_pkg ${QT6_PKG_LIST})
    FIND_PACKAGE(${_pkg} PATHS ${QT6_PATH} REQUIRED)
  ENDFOREACH()
  
  ADD_DEFINITIONS(-DWITH_QT6)
  MESSAGE(STATUS "  [ElmerGUI] Qt6:               " ${Qt6_FOUND})
  MESSAGE(STATUS "  [ElmerGUI] Qt6 Libraries: ${Qt6OpenGL_LIBRARIES} ${Qt6OpenGLWidgets_LIBRARIES} ${Qt6Qml_LIBRARIES} ${Qt6Xml_LIBRARIES} ${Qt6Gui_LIBRARIES} ${Qt6Core_LIBRARIES}")
  MESSAGE(STATUS "------------------------------------------------")
  set(WITH_QT5 FALSE CACHE BOOL "" FORCE)  
ELSEIF(WITH_QT5)
  MESSAGE(STATUS "------------------------------------------------")
  IF(WIN32)
    MESSAGE(STATUS "Qt5 Windows packaging")
    SET(QT5_PKG_LIST Qt5OpenGL Qt5Xml Qt5Script Qt5Gui Qt5Core Qt5Svg Qt5Widgets Qt5PrintSupport)
  ELSE()
    MESSAGE(STATUS "Qt5 non-Windows packaging")
    SET(QT5_PKG_LIST Qt5OpenGL Qt5Xml Qt5Script Qt5Gui Qt5Core Qt5Svg Qt5PrintSupport)
  ENDIF()
  FOREACH(_pkg ${QT5_PKG_LIST})
    FIND_PACKAGE(${_pkg} PATHS ${QT5_PATH} REQUIRED)
  ENDFOREACH()
  ADD_DEFINITIONS(-DWITH_QT5)
  MESSAGE(STATUS "  [ElmerGUI] Qt5:               " ${Qt5_FOUND})
  MESSAGE(STATUS "  [ElmerGUI] Qt5 Libraries: ${Qt5OpenGL_LIBRARIES} ${Qt5Xml_LIBRARIES} ${Qt5Script_LIBRARIES} ${Qt5Gui_LIBRARIES} ${Qt5Core_LIBRARIES}")
  MESSAGE(STATUS "------------------------------------------------")
ELSE()
  MESSAGE(STATUS "------------------------------------------------")
  FIND_PACKAGE(Qt4 COMPONENTS QtOpenGL QtXml QtScript QtGui QtCore REQUIRED)
  MESSAGE(STATUS "  [ElmerGUI] Qt4:               " ${Qt4_FOUND})
  MESSAGE(STATUS "  [ElmerGUI] Qt4_LIBRARIES:     " ${Qt4_LIBRARY})
  MESSAGE(STATUS "------------------------------------------------")
ENDIF()

IF(WITH_PYTHONQT)
  IF(WITH_QT5 OR WITH_QT6)
    MESSAGE(FATAL_ERROR "PythonQt is not supported for QT5 or QT6")
  ENDIF()
  ADD_DEFINITIONS(-DEG_PYTHONQT)
  ADD_SUBDIRECTORY(PythonQt)
  SET(APPLICATION_INCLUDE_DIRS "${APPLICATION_INCLUDE_DIRS};${CMAKE_CURRENT_SOURCE_DIR}/PythonQt/src")
ENDIF()

SET_DIRECTORY_PROPERTIES(Application INCLUDE_DIRECTORIES "${APPLICATION_INCLUDE_DIRS}")

IF(WITH_QWT)
  ADD_DEFINITIONS(-DEG_QWT)
  FIND_PACKAGE(Qwt REQUIRED)
#  FIND_PATH(QWT_INCLUDE_DIR qwt.h)
#  SET(QWT_INCLUDE_DIR "C:/msys64/mingw64/include/qwt-qt5")
#  SET(QWT_LIBRARY "C:/msys64/mingw64/lib/libqwt-qt5.dll.a")
  MESSAGE(STATUS "  [ElmerGUI] Qwt:             " ${Qwt_FOUND})
  MESSAGE(STATUS "  [ElmerGUI] QWT_LIBRARY:     " ${QWT_LIBRARY})
  MESSAGE(STATUS "  [ElmerGUI] QWT_INCLUDE_DIR: " ${QWT_INCLUDE_DIR})
  MESSAGE(STATUS "------------------------------------------------")
  string(FIND "${QWT_LIBRARY}" "-qt6" QWT_QT_OUT)
  if( (QWT_QT_OUT GREATER 0) AND (NOT WITH_QT6))
    MESSAGE(WARNING "  [ElmerGUI] Qt version mismatch with Qwt")
    MESSAGE(STATUS "------------------------------------------------")
  endif()
  string(FIND "${QWT_LIBRARY}" "-qt5" QWT_QT_OUT)
  if( (QWT_QT_OUT GREATER 0) AND (NOT WITH_QT5))
    MESSAGE(WARNING "  [ElmerGUI] Qt version mismatch with Qwt")
    MESSAGE(STATUS "------------------------------------------------")
  endif()
  string(FIND "${QWT_LIBRARY}" "-qt4" QWT_QT_OUT)
  if( (QWT_QT_OUT GREATER 0) AND (WITH_QT5 OR WITH_QT6))
    MESSAGE(WARNING "  [ElmerGUI] Qt version mismatch with Qwt")
    MESSAGE(STATUS "------------------------------------------------")
  endif()  
ENDIF()

IF(WITH_OCC)

  IF(NOT WITH_VTK)
    SET(WITHOUT_VTKPOST TRUE)
  ENDIF()
  SET(WITH_VTK TRUE)
  ADD_DEFINITIONS(-DEG_OCC)

  FIND_PACKAGE(OpenCASCADE)
  IF(OpenCASCADE_FOUND)
    MESSAGE(STATUS "  [ElmerGUI] OpenCASCADE:               " ${OpenCASCADE_FOUND})
    MESSAGE(STATUS "  [ElmerGUI] OpenCASCADE_VERSION:       " ${OpenCASCADE_VERSION})
    MESSAGE(STATUS "  [ElmerGUI] OpenCASCADE_INCLUDE_DIR:   " ${OpenCASCADE_INCLUDE_DIR})
    # only link to available libraries
    SET(ELMER_USED_OCC_LIBS "TKernel;TKMath;TKG3d;TKG2d;TKBRep;TKSTEP;TKMesh;TKIGES;TKDEIGES;TKG2d;TKGeomBase;TKBool;TKBO;TKGeomAlgo;TKPrim;TKShHealing;TKSTEP209;TKSTEPAttr;TKSTEPBase;TKDESTEP;TKTopAlgo;TKXSBase")
    SET(ELMER_AVAILABLE_OCC_LIBS "")
    FOREACH(_lib IN LISTS ELMER_USED_OCC_LIBS)
      LIST(FIND OpenCASCADE_LIBRARIES ${_lib} _index)
      IF(NOT ${_index} EQUAL -1)
        LIST(APPEND ELMER_AVAILABLE_OCC_LIBS ${_lib})
      ENDIF()
    ENDFOREACH()
    SET(ELMER_OCC_LIBS "${ELMER_AVAILABLE_OCC_LIBS}" CACHE INTERNAL "")
    MESSAGE(STATUS "  [ElmerGUI] ELMER_OCC_LIBS:    " "${ELMER_OCC_LIBS}")
    MESSAGE(STATUS "------------------------------------------------")
  ELSE()
    FIND_PACKAGE(OCE REQUIRED)
    MESSAGE(STATUS "  [ElmerGUI] OCE:               " ${OCE_FOUND})
    MESSAGE(STATUS "  [ElmerGUI] OCE_VERSION:       " ${OCE_VERSION})
    MESSAGE(STATUS "  [ElmerGUI] OCE_INCLUDE_DIRS:  " ${OCE_INCLUDE_DIRS})
    SET(ELMER_OCC_LIBS "TKernel;TKMath;TKG3d;TKG2d;TKBRep;TKSTEP;TKMesh;TKIGES;TKG2d;TKGeomBase;TKBool;TKBO;TKGeomAlgo;TKPrim;TKShHealing;TKSTEP209;TKSTEPAttr;TKSTEPBase;TKTopAlgo;TKXSBase" CACHE INTERNAL "")
    MESSAGE(STATUS "  [ElmerGUI] ELMER_OCC_LIBS:    " "${ELMER_OCC_LIBS}")
    MESSAGE(STATUS "------------------------------------------------")
    SET(OpenCASCADE_INCLUDE_DIR ${OCE_INCLUDE_DIRS} CACHE PATH "Include dir for OCCT or OCE")
  ENDIF()
  
ENDIF()

IF(WITH_VTK)
  FIND_PACKAGE(VTK REQUIRED)

  # We do not use Java wrappings and they make linking very difficult when
  # building Debian/Ubuntu packages
  LIST(REMOVE_ITEM VTK_LIBRARIES VTK::Java)

  INCLUDE(testVTKcapabilities)

  MESSAGE(STATUS "  [ElmerGUI] VTK version:       " ${VTK_VERSION})
  MESSAGE(STATUS "  [ElmerGUI] VTK_LIBS:          " "${VTK_LIBRARIES}")
  MESSAGE(STATUS "  [ElmerGUI] VTK_INCLUDE_DIRS:  " "${VTK_INCLUDE_DIRS}")
  MESSAGE(STATUS "  [ElmerGUI] VTK_QT_VERSION:    " ${VTK_QT_VERSION})
  MESSAGE(STATUS "------------------------------------------------")
  if((${VTK_QT_VERSION} EQUAL 6) AND (NOT WITH_QT6))
    MESSAGE(WARNING "  [ElmerGUI] Qt version mismatch with VTK_QT_VERSION")
    MESSAGE(STATUS "------------------------------------------------")
  elseif((${VTK_QT_VERSION} EQUAL 5) AND (NOT WITH_QT5))
    MESSAGE(WARNING "  [ElmerGUI] Qt version mismatch with VTK_QT_VERSION")
    MESSAGE(STATUS "------------------------------------------------")
  elseif((${VTK_QT_VERSION} EQUAL 4) AND (WITH_QT5 OR WITH_QT6))
    MESSAGE(WARNING "  [ElmerGUI] Qt version mismatch with VTK_QT_VERSION")
    MESSAGE(STATUS "------------------------------------------------")
  endif()
ENDIF()

IF(WITH_MATC)
  ADD_DEFINITIONS(-DEG_MATC)
  ADD_SUBDIRECTORY(matc)
  MESSAGE(STATUS "  [ElmerGUI] Compiling in matc")
  MESSAGE(STATUS "------------------------------------------------")
ENDIF()

IF(WITH_PARAVIEW)
  ADD_DEFINITIONS(-DEG_PARAVIEW)
ENDIF()


ADD_SUBDIRECTORY(netgen)
ADD_SUBDIRECTORY(Application)


IF(WIN32)
  INCLUDE(cmake/windows_bundle.cmake)
ENDIF(WIN32)

INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/LICENSES DESTINATION "share/ElmerGUI/license_texts" COMPONENT "elmergui")
INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/GPL-2 DESTINATION "share/ElmerGUI/license_texts" COMPONENT "elmergui")
INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/GPL_EXCEPTION DESTINATION "share/ElmerGUI/license_texts" COMPONENT "elmergui")
INSTALL(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/samples DESTINATION "share/ElmerGUI" COMPONENT "elmergui_samples")

=== ElmerGUItester/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.10)
PROJECT(ElmerGUItester CXX)


IF(WITH_QT6)
  MESSAGE(STATUS "------------------------------------------------")
  SET(QT6_PKG_LIST Qt6Gui Qt6Core Qt6OpenGLWidgets)
  FOREACH(_pkg ${QT6_PKG_LIST})
    FIND_PACKAGE(${_pkg} PATHS ${QT6_PATH})
  ENDFOREACH()
  MESSAGE(STATUS "  [ElmerGUItester] Qt6:               " ${Qt6_FOUND})
  MESSAGE(STATUS "  [ElmerGUItester] Qt6 Libraries: ${Qt6OpenGLWidgets_LIBRARIES} ${Qt6Gui_LIBRARIES} ${Qt6Core_LIBRARIES}")
  MESSAGE(STATUS "------------------------------------------------")
  ADD_DEFINITIONS(-DWITH_QT6)
ELSEIF(WITH_QT5)
  MESSAGE(STATUS "------------------------------------------------")
  SET(QT5_PKG_LIST Qt5Gui Qt5Core Qt5Widgets)
  FOREACH(_pkg ${QT5_PKG_LIST})
    FIND_PACKAGE(${_pkg} PATHS ${QT5_PATH})
  ENDFOREACH()
  MESSAGE(STATUS "  [ElmerGUItester] Qt5:               " ${Qt5_FOUND})
  MESSAGE(STATUS "  [ElmerGUItester] Qt5 Libraries: ${Qt5Widgets_LIBRARIES} ${Qt5Gui_LIBRARIES} ${Qt5Core_LIBRARIES}")
  MESSAGE(STATUS "------------------------------------------------")
  ADD_DEFINITIONS(-DWITH_QT5)
ELSE()
  FIND_PACKAGE(Qt4 COMPONENTS QtGui QtCore REQUIRED)
ENDIF()

SET(CMAKE_INCLUDE_CURRENT_DIR ON)
SET(CMAKE_AUTOMOC ON)
SET(CMAKE_AUTORCC ON)
SET(CMAKE_AUTOUIC OFF)

SET(TARGETS ElmerGUItester)

SET(HEADERS src/tester.h)
SET(FORMS forms/mainform.ui)
SET(SOURCES src/main.cpp src/tester.cpp)

SET(RESOURCES ElmerGUItester.qrc)
SET(WIN32_RC_FILE ElmerGUItester.rc)

IF(WITH_QT6)
  QT6_WRAP_UI(UI_HEADERS ${FORMS})
  QT6_ADD_RESOURCES(UI_RESOURCES ${RESOURCES})
ELSEIF(WITH_QT5)
  QT5_WRAP_UI(UI_HEADERS ${FORMS})
  QT5_ADD_RESOURCES(UI_RESOURCES ${RESOURCES})
ELSE()
  QT4_WRAP_UI(UI_HEADERS ${FORMS})
  QT4_ADD_RESOURCES(UI_RESOURCES ${RESOURCES})
  INCLUDE(${QT_USE_FILE})
  ADD_DEFINITIONS(${QT_DEFINITIONS})
ENDIF()

IF(MINGW AND WIN32)
  SET(CMAKE_RC_COMPILER_INIT windres)
  ENABLE_LANGUAGE(RC)
  SET(CMAKE_RC_COMPILE_OBJECT
    "<CMAKE_RC_COMPILER> <FLAGS> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
  SET(SOURCES ${SOURCES} ${WIN32_RC_FILE})
ENDIF()

INCLUDE_DIRECTORIES(${APPLICATION_INCLUDE_DIRS})
ADD_EXECUTABLE(ElmerGUItester WIN32 ${SOURCES} ${UI_HEADERS} ${UI_RESOURCES})

IF(WITH_QT6)
  TARGET_LINK_LIBRARIES(ElmerGUItester Qt6::OpenGLWidgets Qt6::Gui Qt6::Core)
ELSEIF(WITH_QT5)
  QT5_USE_MODULES(ElmerGUItester Gui Core Widgets)
ENDIF()

TARGET_LINK_LIBRARIES(ElmerGUItester ${QT_LIBRARIES})
INSTALL(TARGETS ElmerGUItester RUNTIME DESTINATION "bin" COMPONENT "elmergui")

=== elmerice/CMakeLists.txt ===
INCLUDE(CheckIncludeFiles)

SET(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${PROJECT_SOURCE_DIR}/elmerice/cmake/Modules")
#TODO: is this proper way of choosing shared library API?
IF(WIN32)
  UNSET(HAVE_DLOPEN_API)
  SET(HAVE_LOADLIBRARY_API TRUE)
ELSEIF(UNIX)
  SET(HAVE_DLOPEN_API TRUE)
  SET(HAVE_DLSYM TRUE)
ENDIF()


INCLUDE(CheckTypeSize)
CHECK_TYPE_SIZE(long LONG_SIZE)
IF(LONG_SIZE EQUAL 4)
  SET(OFF_KIND "selected_int_kind(9)")
ELSEIF(LONG_SIZE EQUAL 8)
  SET(OFF_KIND "selected_int_kind(18)")
ENDIF()

SET(ELMER_SOLVER_HOME "${CMAKE_INSTALL_PREFIX}/share/elmersolver" CACHE PATH "")

SET(SHL_EXTENSION ".so")
IF(WIN32)
  SET(SHL_EXTENSION ".dll")
ENDIF()
IF(APPLE)
  SET(SHL_EXTENSION ".dylib")
ENDIF()

INCLUDE_DIRECTORIES("${PROJECT_BINARY_DIR}")


IF (WITH_PROJ4)
  FIND_PACKAGE(PROJ)
  FIND_PACKAGE(FORTRANGIS)

  IF(PROJ_FOUND AND FORTRANGIS_FOUND)
    SET(HAVE_PROJ TRUE)
    SET(HAVE_FORTRANGIS TRUE)
    MARK_AS_ADVANCED(HAVE_PROJ HAVE_FORTRANGIS)
    ADD_DEFINITIONS(-DHAVE_PROJ)
    MESSAGE(STATUS "  PROJ & FORTRANGIS: " "${PROJ_FOUND} & ${FORTRANGIS_FOUND}")
    MESSAGE(STATUS "  PROJ_INC:   " "${PROJ_INCLUDE_DIR}")
    MESSAGE(STATUS "  PROJ_LIB:   " "${PROJ_LIBRARY}")
    MESSAGE(STATUS "  FORTRANGIS_INC:  " "${FORTRANGIS_INCLUDE_DIR}")
    MESSAGE(STATUS "  FORTRANGIS_LIB:  " "${FORTRANGIS_LIBRARY}")

    MESSAGE(STATUS "Compile ProjUtils with Proj4 support")
  ELSE()
    MESSAGE(STATUS "Library not found: >PROJ_FOUND< = ${PROJ_FOUND} and/or >FORTRANGIS_FOUND< =  ${FORTRANGIS_FOUND}")
    MESSAGE(WARNING "  \n Missing: >PROJ_INCLUDE_DIR< , >PROJ_LIBRARY< , >FORTRANGIS_INCLUDE_DIR< , >FORTRANGIS_LIBRARY< \n to compile ProjUtils support for Proj4")
  ENDIF()
ENDIF()

ADD_SUBDIRECTORY(Utils)
ADD_SUBDIRECTORY(UserFunctions)
ADD_SUBDIRECTORY(Solvers)
IF(BUILD_TESTING)
  ADD_SUBDIRECTORY(Tests)
ENDIF()

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/Solvers/Permafrost/permafrostmaterialdb.dat
  ${CMAKE_CURRENT_BINARY_DIR}/Solvers/Permafrost/permafrostmaterialdb.dat COPYONLY)

INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/Solvers/Permafrost/permafrostmaterialdb.dat  DESTINATION "share/elmersolver/lib")

=== fem/CMakeLists.txt ===

INCLUDE(CheckIncludeFiles)

CHECK_INCLUDE_FILES(inttypes.h HAVE_INTTYPES_H)


FUNCTION(FORTRANIZE infile outfile)
  SET(RESULT "")
  FILE(STRINGS "${infile}" lines)
  FOREACH(i IN LISTS lines)
    STRING(REGEX REPLACE "/\\*.*\\*/" "" i "${i}")
    IF(i)
      SET(RESULT "${RESULT}${i}\n")
    ENDIF(i)
  ENDFOREACH()
  FILE(WRITE "${outfile}" "${RESULT}")
ENDFUNCTION(FORTRANIZE infile outfile)

#TODO: is this proper way of choosing shared library API?
IF(WIN32)
  UNSET(HAVE_DLOPEN_API)
  SET(HAVE_LOADLIBRARY_API TRUE)
ELSEIF(UNIX)
  SET(HAVE_DLOPEN_API TRUE)
  SET(HAVE_DLSYM TRUE)
ENDIF()

#STRING(COMPARE EQUAL ${FortranCInterface_GLOBAL_CASE} "LOWER" FC_LINK_CASE)
#STRING(COMPARE EQUAL ${FortranCInterface_GLOBAL_SUFFIX} "" FC_LINK_SUFFIX)
#IF(FC_LINK_CASE)
#  IF(FC_LINK_SUFFIX)
#    SET(ELMER_LINKTYP 3)
#  ELSE()
#    SET(ELMER_LINKTYP 1)
#  ENDIF()
#ELSE()
#  SET(ELMER_LINKTYP 2)
#ENDIF()

#FIND_FILE(FEM_LICENSES LICENSES PATHS ${CMAKE_CURRENT_SOURCE_DIR} NO_DEFAULT_PATH)
#MARK_AS_ADVANCED(FEM_LICENSES)
#INSTALL(FILES ${FEM_LICENSES} DESTINATION "share/elmersolver/license_texts/fem")
INSTALL(FILES "LICENSES" DESTINATION "share/elmersolver/license_texts/fem")
#MARK_AS_ADVANCED(FEM_LICENSES)

INCLUDE(CheckTypeSize)
CHECK_TYPE_SIZE(long LONG_SIZE)
IF(LONG_SIZE EQUAL 4)
  SET(OFF_KIND "selected_int_kind(9)")
ELSEIF(LONG_SIZE EQUAL 8)
  SET(OFF_KIND "selected_int_kind(18)")
ENDIF()

#SET(FC_CHAR_PTR "(P,L) char *P, int L")
SET(ELMER_SOLVER_HOME "${CMAKE_INSTALL_PREFIX}/share/elmersolver" CACHE PATH "")

SET(SHL_EXTENSION ".so")
IF(WIN32)
  SET(SHL_EXTENSION ".dll")
ENDIF()
IF(APPLE)
  SET(SHL_EXTENSION ".dylib")
ENDIF()

CONFIGURE_FILE(config.h.cmake config.h.commented)
FORTRANIZE(${CMAKE_BINARY_DIR}/fem/config.h.commented ${CMAKE_BINARY_DIR}/fem/config.h)

INCLUDE_DIRECTORIES("${PROJECT_BINARY_DIR}")
ADD_SUBDIRECTORY(src)
IF(BUILD_TESTING)
  ADD_SUBDIRECTORY(tests)
ENDIF()

=== ElmerGUI/Application/CMakeLists.txt ===
SET(CMAKE_INCLUDE_CURRENT_DIR ON)
SET(CMAKE_AUTOMOC ON)
SET(CMAKE_AUTORCC ON)
SET(CMAKE_AUTOUIC OFF)
#FIND_PACKAGE(Qt4 COMPONENTS QtOpenGL QtXml QtScript QtGui QtCore REQUIRED)

SET(HEADERS src/bodypropertyeditor.h 
  src/boundarydivision.h 
  src/boundarypropertyeditor.h 
  src/checkmpi.h 
  src/dynamiceditor.h 
  src/edfeditor.h 
  src/egini.h 
  src/generalsetup.h 
  src/glcontrol.h 
  src/glwidget.h 
  src/helpers.h 
  src/mainwindow.h 
  src/materiallibrary.h 
  src/maxlimits.h 
  src/meshcontrol.h 
  src/meshingthread.h 
  src/meshtype.h 
  src/meshutils.h 
  src/operation.h 
  src/parallel.h 
  src/projectio.h 
  src/sifgenerator.h 
  src/sifwindow.h 
  src/solverparameters.h 
  src/summaryeditor.h 
  src/objectbrowser.h 
  src/solverlogwindow.h 
  src/newprojectdialog.h 
  plugins/egconvert.h 
  plugins/egdef.h 
  plugins/egmain.h 
  plugins/egmesh.h 
  plugins/egnative.h 
  plugins/egtypes.h 
  plugins/egutils.h 
  plugins/elmergrid_api.h 
  plugins/nglib_api.h 
  plugins/tetgen.h 
  plugins/tetlib_api.h 
  twod/renderarea.h 
  twod/twodview.h 
  twod/curveeditor.h)


SET(FORMS forms/bodypropertyeditor.ui 
  forms/boundarydivision.ui 
  forms/boundarypropertyeditor.ui 
  forms/generalsetup.ui 
  forms/glcontrol.ui 
  forms/materiallibrary.ui 
  forms/meshcontrol.ui 
  forms/parallel.ui 
  forms/solverparameters.ui 
  forms/summaryeditor.ui
  forms/newproject.ui)


SET(SOURCES src/bodypropertyeditor.cpp 
  src/boundarydivision.cpp 
  src/boundarypropertyeditor.cpp 
  src/checkmpi.cpp 
  src/dynamiceditor.cpp 
  src/edfeditor.cpp 
  src/egini.cpp 
  src/generalsetup.cpp 
  src/glcontrol.cpp 
  src/glwidget.cpp 
  src/helpers.cpp 
  src/main.cpp 
  src/mainwindow.cpp 
  src/materiallibrary.cpp 
  src/maxlimits.cpp 
  src/meshcontrol.cpp 
  src/meshingthread.cpp 
  src/meshtype.cpp 
  src/meshutils.cpp 
  src/operation.cpp 
  src/parallel.cpp 
  src/projectio.cpp 
  src/sifgenerator.cpp 
  src/sifwindow.cpp 
  src/solverparameters.cpp 
  src/summaryeditor.cpp 
  src/solverlogwindow.cpp 
  src/objectbrowser.cpp 
  src/newprojectdialog.cpp
  plugins/egconvert.cpp 
  plugins/egmain.cpp 
  plugins/egmesh.cpp 
  plugins/egnative.cpp 
  plugins/egutils.cpp 
  plugins/elmergrid_api.cpp 
  plugins/nglib_api.cpp 
  plugins/tetlib_api.cpp 
  twod/renderarea.cpp 
  twod/twodview.cpp 
  twod/curveeditor.cpp)

ADD_DEFINITIONS(-DEG_PLUGIN)

IF(WITH_QWT)
  SET(HEADERS ${HEADERS} src/convergenceview.h)
  SET(SOURCES ${SOURCES} src/convergenceview.cpp)
ENDIF(WITH_QWT)

IF(WITH_VTK AND NOT WITHOUT_VTKPOST)
  ADD_DEFINITIONS(-DEG_VTK)
  #FIND_PACKAGE(VTK REQUIRED)
  IF(${VTK_VERSION} VERSION_LESS 8.90)
    INCLUDE(${VTK_USE_FILE})
  ENDIF()
  SET(HEADERS ${HEADERS}
    vtkpost/axes.h 
    vtkpost/featureedge.h 
    vtkpost/vtkpost.h 
    vtkpost/isosurface.h 
    vtkpost/isocontour.h 
    vtkpost/epmesh.h 
    vtkpost/colorbar.h 
    vtkpost/meshpoint.h 
    vtkpost/meshedge.h 
    vtkpost/surface.h 
    vtkpost/preferences.h 
    vtkpost/vector.h 
    vtkpost/readepfile.h 
    vtkpost/streamline.h 
    vtkpost/timestep.h 
    vtkpost/ecmaconsole.h 
    vtkpost/text.h)

  SET(FORMS ${FORMS}
    vtkpost/axes.ui 
    vtkpost/featureedge.ui 
    vtkpost/isosurface.ui 
    vtkpost/isocontour.ui 
    vtkpost/colorbar.ui 
    vtkpost/surface.ui 
    vtkpost/meshpoint.ui 
    vtkpost/meshedge.ui 
    vtkpost/preferences.ui 
    vtkpost/vector.ui 
    vtkpost/readepfile.ui 
    vtkpost/streamline.ui 
    vtkpost/timestep.ui 
    vtkpost/text.ui)

  SET(SOURCES ${SOURCES}
    vtkpost/axes.cpp 
    vtkpost/featureedge.cpp 
    vtkpost/vtkpost.cpp 
    vtkpost/isosurface.cpp 
    vtkpost/isocontour.cpp 
    vtkpost/epmesh.cpp 
    vtkpost/colorbar.cpp 
    vtkpost/meshpoint.cpp 
    vtkpost/meshedge.cpp 
    vtkpost/surface.cpp 
    vtkpost/preferences.cpp 
    vtkpost/vector.cpp 
    vtkpost/readepfile.cpp 
    vtkpost/streamline.cpp 
    vtkpost/timestep.cpp 
    vtkpost/ecmaconsole.cpp 
    vtkpost/text.cpp)

  IF(WITH_MATC)
    SET(HEADERS ${HEADERS} vtkpost/matc.h  vtkpost/mc.h)
    SET(FORMS ${FORMS} vtkpost/matc.ui)
    SET(SOURCES ${SOURCES} vtkpost/matc.cpp)
  ENDIF(WITH_MATC)

ENDIF()

IF(WITH_OCC)

#  set(ELMER_USE_OCC_VARIANT "Official Version"  CACHE STRING  "Official OpenCASCADE version or community edition")
#  set_property(CACHE ELMER_USE_OCC_VARIANT PROPERTY STRINGS
#              "Official Version"
#              "Community Edition"
#  )

  SET(HEADERS ${HEADERS} cad/cadview.h  cad/cadpreferences.h)
  SET(FORMS ${FORMS} cad/cadpreferences.ui)
  SET(SOURCES ${SOURCES} cad/cadview.cpp cad/cadpreferences.cpp)
ENDIF()

IF(WITH_QT6)
  SET(DESIRED_QT_VERSION "6")
  QT6_WRAP_UI(UI_HEADERS ${FORMS})
  QT6_ADD_RESOURCES(UI_RESOURCES ElmerGUI.qrc)
  ADD_DEFINITIONS(-DWITH_QT6)
ELSEIF(WITH_QT5)
  SET(DESIRED_QT_VERSION "5")
  QT5_WRAP_UI(UI_HEADERS ${FORMS})
  QT5_ADD_RESOURCES(UI_RESOURCES ElmerGUI.qrc)
  ADD_DEFINITIONS(-DWITH_QT5)
ELSE()
  SET(DESIRED_QT_VERSION "4")
  QT4_WRAP_UI(UI_HEADERS ${FORMS})
  QT4_ADD_RESOURCES(UI_RESOURCES ElmerGUI.qrc)
  INCLUDE(${QT_USE_FILE})
ENDIF()
ADD_DEFINITIONS(${QT_DEFINITIONS})

IF(MINGW AND WIN32)
  SET(CMAKE_RC_COMPILER_INIT windres)
  ENABLE_LANGUAGE(RC)
  SET(CMAKE_RC_COMPILE_OBJECT
    "<CMAKE_RC_COMPILER> <FLAGS> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
  SET(SOURCES ${SOURCES} ElmerGUI.rc)
ENDIF()

ADD_EXECUTABLE(ElmerGUI WIN32 ${SOURCES} ${UI_HEADERS} ${UI_RESOURCES})
SET(CPACK_PACKAGE_EXECUTABLES ElmerGUI "ElmerGUI")

IF(WITH_QT6)
  TARGET_LINK_LIBRARIES(ElmerGUI Qt6::OpenGLWidgets Qt6::Qml Qt6::Xml Qt6::Gui Qt6::Core Qt6::Svg Qt6::Widgets Qt6::PrintSupport Qt6::OpenGLWidgets) 
ELSEIF(WITH_QT5)
  QT5_USE_MODULES(ElmerGUI OpenGL Xml Script Gui Core Svg Widgets PrintSupport)
ENDIF()

TARGET_LINK_LIBRARIES(ElmerGUI ng ${QT_LIBRARIES})
IF(NOT(WIN32) AND NOT(APPLE))
  TARGET_LINK_LIBRARIES(ElmerGUI GL GLU)
ENDIF()

IF(APPLE)
  SET_TARGET_PROPERTIES(ElmerGUI PROPERTIES COMPILE_FLAGS "-framework OpenGL -framework GLU")
  SET_TARGET_PROPERTIES(ElmerGUI PROPERTIES LINK_FLAGS "-Wl,-framework,OpenGL")
ENDIF()


IF(WIN32)
  TARGET_LINK_LIBRARIES(ElmerGUI opengl32 glu32 psapi)
  ADD_DEFINITIONS(-DPSAPI_VERSION=1)
ENDIF(WIN32)

IF(WITH_MATC)
  TARGET_LINK_LIBRARIES(ElmerGUI matc)
ENDIF()

IF(WITH_QWT)
  INCLUDE_DIRECTORIES(${QWT_INCLUDE_DIR})
  TARGET_LINK_LIBRARIES(ElmerGUI ${QWT_LIBRARY})
ENDIF()

IF(WITH_VTK)
  TARGET_LINK_LIBRARIES(ElmerGUI ${VTK_LIBRARIES})
  IF(VTK_MAJOR_VERSION VERSION_LESS 6)
    TARGET_LINK_LIBRARIES(ElmerGUI QVTK)
  ENDIF()
  IF(ELMER_INSTANTIATE_VTK_ARRAY_TEMPLATE)
    TARGET_COMPILE_DEFINITIONS(ElmerGUI PRIVATE ELMER_INSTANTIATE_VTK_ARRAY_TEMPLATE)
  ENDIF()
ENDIF()

IF(WITH_OCC)
  TARGET_LINK_LIBRARIES(ElmerGUI ${ELMER_OCC_LIBS})
  INCLUDE_DIRECTORIES(${OpenCASCADE_INCLUDE_DIR})
  IF(UNIX)
    ADD_DEFINITIONS(-DHAVE_CONFIG_H -DHAVE_IOSTREAM -DHAVE_FSTREAM -DHAVE_LIMITS_H) 
  ELSEIF(WIN32)
    ADD_DEFINITIONS(-DWNT -DCSFDB)
  ENDIF()
ENDIF()

IF(WITH_PYTHONQT)
  MESSAGE(WARNING "PythonQT is not tested.")
  INCLUDE_DIRECTORIES(${PYTHONQT_INCLUDE_DIR} ${PYTHON_INCLUDE_DIR})
  TARGET_LINK_LIBRARIES(ElmerGUI PythonQt)
ENDIF()

IF(NOT(WIN32) AND ELMERSOLVER_RPATH_STRING)
  SET_TARGET_PROPERTIES(ElmerGUI PROPERTIES INSTALL_RPATH "${ELMERSOLVER_RPATH_STRING}")
ENDIF()
INSTALL(TARGETS ElmerGUI RUNTIME DESTINATION "bin" COMPONENT "elmergui")
INSTALL(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/edf DESTINATION "share/ElmerGUI" COMPONENT "elmergui")
INSTALL(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/edf-extra DESTINATION "share/ElmerGUI" COMPONENT "elmergui")

INSTALL(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/icons/TangoElmerGUI DESTINATION "share/ElmerGUI/icons" COMPONENT "elmergui")

=== ElmerGUI/matc/CMakeLists.txt ===
#PROJECT(matc C)

FILE(GLOB SOURCES "src/*.c")
#MESSAGE(STATUS "SOURCES: ${SOURCES}")

IF(NOT(WITH_ELMERGUI))
  ADD_LIBRARY(matc ${SOURCES})
  INSTALL(TARGETS matc RUNTIME DESTINATION "bin" LIBRARY DESTINATION "lib"
    ARCHIVE DESTINATION "lib" COMPONENT "elmergui")
ENDIF()

=== ElmerGUI/netgen/CMakeLists.txt ===
#----------------------------------------------------------------------
#                       qmake project file for libng
#----------------------------------------------------------------------
#include(../ElmerGUI.pri)
#PROJECT(netgen CXX)

INCLUDE_DIRECTORIES("libsrc/include")
ADD_DEFINITIONS("-DNO_PARALLEL_THREADS")

#------------------------------------------------------------------------------
# Compiler flags:
#------------------------------------------------------------------------------
#QMAKE_CXXFLAGS_DEBUG += -g
#QMAKE_CXXFLAGS += -g

#------------------------------------------------------------------------------
# Input files:
#------------------------------------------------------------------------------
SET(SOURCES libsrc/opti/linopt.cpp 
          libsrc/opti/bfgs.cpp 
          libsrc/opti/linsearch.cpp 
          libsrc/meshing/global.cpp 
          libsrc/meshing/bisect.cpp 
          libsrc/meshing/meshtool.cpp 
          libsrc/meshing/refine.cpp 
          libsrc/meshing/ruler3.cpp 
          libsrc/meshing/improve3.cpp 
          libsrc/meshing/smoothing3.cpp 
          libsrc/meshing/adfront3.cpp 
          libsrc/meshing/tetrarls.cpp 
          libsrc/meshing/prism2rls.cpp 
          libsrc/meshing/pyramidrls.cpp 
          libsrc/meshing/pyramid2rls.cpp 
          libsrc/meshing/netrule3.cpp 
          libsrc/meshing/ruler2.cpp 
          libsrc/meshing/meshclass.cpp 
          libsrc/meshing/improve2.cpp 
          libsrc/meshing/smoothing2.cpp 
          libsrc/meshing/smoothing2.5.cpp 
          libsrc/meshing/adfront2.cpp 
          libsrc/meshing/netrule2.cpp 
          libsrc/meshing/triarls.cpp 
          libsrc/meshing/geomsearch.cpp 
          libsrc/meshing/secondorder.cpp 
          libsrc/meshing/meshtype.cpp 
          libsrc/meshing/parser3.cpp 
          libsrc/meshing/meshing2.cpp 
          libsrc/meshing/quadrls.cpp 
          libsrc/meshing/specials.cpp 
          libsrc/meshing/parser2.cpp 
          libsrc/meshing/meshing3.cpp 
          libsrc/meshing/meshfunc.cpp 
          libsrc/meshing/localh.cpp 
          libsrc/meshing/improve2gen.cpp 
          libsrc/meshing/delaunay.cpp 
          libsrc/meshing/boundarylayer.cpp 
          libsrc/meshing/msghandler.cpp 
          libsrc/meshing/meshfunc2d.cpp 
          libsrc/meshing/topology.cpp 
          libsrc/meshing/clusters.cpp 
          libsrc/meshing/curvedelems_new.cpp 
          libsrc/meshing/hprefinement.cpp 
          libsrc/meshing/validate.cpp 
          libsrc/interface/nglib.cpp 
          libsrc/gprim/geomtest3d.cpp 
          libsrc/gprim/geom2d.cpp 
          libsrc/gprim/geom3d.cpp 
          libsrc/gprim/adtree.cpp 
          libsrc/gprim/transform3d.cpp 
          libsrc/gprim/geomfuncs.cpp 
          libsrc/linalg/polynomial.cpp 
          libsrc/linalg/densemat.cpp 
          libsrc/linalg/vector.cpp 
          libsrc/csg/algprim.cpp 
          libsrc/csg/brick.cpp 
          libsrc/csg/manifold.cpp 
          libsrc/csg/bspline2d.cpp 
          libsrc/csg/meshsurf.cpp 
          libsrc/csg/csgeom.cpp 
          libsrc/csg/polyhedra.cpp 
          libsrc/csg/curve2d.cpp 
          libsrc/csg/singularref.cpp 
          libsrc/csg/edgeflw.cpp 
          libsrc/csg/solid.cpp 
          libsrc/csg/explicitcurve2d.cpp 
          libsrc/csg/specpoin.cpp 
          libsrc/csg/gencyl.cpp 
          libsrc/csg/revolution.cpp 
          libsrc/csg/genmesh.cpp 
          libsrc/csg/spline3d.cpp 
          libsrc/csg/surface.cpp 
          libsrc/csg/identify.cpp 
          libsrc/csg/triapprox.cpp 
          libsrc/csg/csgparser.cpp 
          libsrc/csg/extrusion.cpp 
          libsrc/geom2d/geom2dmesh.cpp 
          libsrc/geom2d/spline.cpp 
          libsrc/geom2d/splinegeometry.cpp 
          libsrc/geom2d/genmesh2d.cpp 
          libsrc/stlgeom/meshstlsurface.cpp 
          libsrc/stlgeom/stlline.cpp 
          libsrc/stlgeom/stltopology.cpp 
          libsrc/stlgeom/stltool.cpp 
          libsrc/stlgeom/stlgeom.cpp 
          libsrc/stlgeom/stlgeomchart.cpp 
          libsrc/stlgeom/stlgeommesh.cpp 
          libsrc/general/moveablemem.cpp 
          libsrc/general/ngexception.cpp 
          libsrc/general/table.cpp 
          libsrc/general/optmem.cpp 
          libsrc/general/spbita2d.cpp 
          libsrc/general/hashtabl.cpp 
          libsrc/general/sort.cpp 
          libsrc/general/flags.cpp 
          libsrc/general/seti.cpp 
          libsrc/general/bitarray.cpp 
          libsrc/general/symbolta.cpp 
          libsrc/general/mystring.cpp 
          libsrc/general/profiler.cpp)

ADD_LIBRARY(ng ${SOURCES})
INSTALL(TARGETS ng RUNTIME DESTINATION "bin" LIBRARY DESTINATION "lib/ElmerGUI/ngcore" ARCHIVE DESTINATION "lib/ElmerGUI/ngcore" COMPONENT "elmergui")

=== contrib/lua-5.1.5/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(lua C)
add_subdirectory(src)

=== elmerice/Solvers/CMakeLists.txt ===
#SET(WITH_GridDataReader FALSE CACHE BOOL "Include ElmerIce GridDataReader")
SET(WITH_ScatteredDataInterpolator FALSE CACHE BOOL "Include ElmerIce ScatteredDataInterpolator")
#MARK_AS_ADVANCED(WITH_GridDataReader)
MARK_AS_ADVANCED(WITH_ScatteredDataInterpolator)

# ---------------------- #
# -- netCDF libraries -- #
#----------------------- #
MESSAGE(STATUS "------------------------------------------------")
MESSAGE(STATUS "Elmer/Ice package: Looking for [netCDF] & [netCDF Fortran] libraries")

FIND_PACKAGE(NETCDF MODULE)

IF(NETCDF_FOUND)

  SET(HAVE_NETCDF TRUE)
  MARK_AS_ADVANCED(HAVE_NETCDF)
  INCLUDE_DIRECTORIES(${NETCDF_INCLUDE_DIR})
  ADD_DEFINITIONS(-DHAVE_NETCDF)

  MESSAGE(STATUS "  netCDF:           " "${NETCDF_FOUND}")
  MESSAGE(STATUS "  netCDF_INC:       " "${NETCDF_INCLUDE_DIR}")
  MESSAGE(STATUS "  netCDF_LIBS:      " "${NETCDF_LIBRARIES}")
ELSE()
  MESSAGE(STATUS "Library not found: netCDF ")
  MESSAGE(WARNING "  \n Missing: <NETCDF_INCLUDE_DIR> , <NETCDF_LIBRARY>,  <NETCDFF_LIBRARY> \n some functionalities will be disabled")
ENDIF()

# ---------------------- #
# -- HDF5 libraries -- #
#----------------------- #
MESSAGE(STATUS "------------------------------------------------")
MESSAGE(STATUS "Elmer/Ice package: Looking for [HDF5] & [HDF5 Fortran] libraries")

FIND_PACKAGE(PHDF5)

IF(PHDF5_FOUND)

  SET(HAVE_HDF5 TRUE)
  MARK_AS_ADVANCED(HAVE_HDF5)
  INCLUDE_DIRECTORIES(${PHDF5_INCLUDE_DIR})
  ADD_DEFINITIONS(-DHAVE_HDF5)

  MESSAGE(STATUS "  HDF5:           " "${PHDF5_FOUND}")
  MESSAGE(STATUS "  HDF5_INC:       " "${PHDF5_INCLUDE_DIR}")
  MESSAGE(STATUS "  HDF5_LIBS:     " "${PHDF5_LIBRARIES}")
ELSE()
  MESSAGE(STATUS "Library not found: >HDF5_FOUND< ")
  MESSAGE(WARNING "  \n Missing: >HDF5_INCLUDE_DIR< , >HDF5_LIBRARY<,  >HDF5F_LIBRARY< \n some functionalities will be disabled")
ENDIF(PHDF5_FOUND)


# ---------------------- #
# -- LOOK FOR MMG     -- #
#----------------------- #
IF(HAVE_MMG)
  ADD_SUBDIRECTORY(MeshAdaptation_2D)
ENDIF()

SET(CMAKE_Fortran_MODULE_DIRECTORY
  ${PROJECT_BINARY_DIR}/fmodules CACHE PATH "Directory for Fortran modules")

SET(ElmerIce_SRC ElmerIceUtils.F90 AIFlowSolve_nlD2.F90 AIFlowSolve_nlS2.F90
    CaffeSolver.F90 ComputeDevStress.F90 ComputeEigenValues.F90
    ComputeNormal.F90 ComputeStrainRate.F90 DeformationalHeat.F90
    EPLSolver.F90 FabricSolve.F90 Flowdepth.F90
    ForceToStress.F90 GetHydrostaticLoads.F90  GolfLaw.F90
    GroundedSolver.F90  IntegratedVelocity.F90  IDSSolver.F90
    PorousSolve.F90  pointwise.F90  SIASolver.F90  SSASolver.F90
    ThicknessSolver.F90  TemperateIce.F90  ExportVertically.F90
    AdjointSolver.F90  DJDBeta_Adjoint.F90  DJDmu_Adjoint.F90
    CostSolver_Adjoint.F90  DJDBeta_Robin.F90  DJDmu_Robin.F90
    CostSolver_Robin.F90  m1qn3.F  Grid2DInterpolator.F90
    Optimize_m1qn3Parallel.F90  OutputStrainHeating.F90  UpdateExport.F90
    IntegrateVertically.F90 EnthalpySolver.F90 SubShelfMelt.F90
    ./Adjoint/Adjoint_LinearSolver.F90 ./Adjoint/Adjoint_CostDiscSolver.F90
    ./Adjoint/Adjoint_CostContSolver.F90 ./Adjoint/Adjoint_CostRegSolver.F90
    ./Adjoint/Adjoint_GradientValidation.F90
    ./AdjointStokes/AdjointStokes_GradientMu.F90
    ./AdjointStokes/AdjointStokes_GradientBetaSolver.F90
    ./AdjointSSA/AdjointSSA_AdjointSolver.F90 ./AdjointSSA/AdjointSSA_CostDiscSolver.F90
    ./AdjointSSA/AdjointSSA_CostRegSolver.F90 ./AdjointSSA/AdjointSSA_SSASolver.F90
    ./AdjointSSA/AdjointSSA_CostContSolver.F90 ./AdjointSSA/AdjointSSA_CostFluxDivSolver.F90
    ./AdjointSSA/AdjointSSA_CostTaubSolver.F90
    ./AdjointSSA/AdjointSSA_GradientSolver.F90
    ./AdjointThickness/AdjointThickness_GradientSolver.F90   ./AdjointThickness/AdjointThickness_ThicknessSolver.F90
    ./Permafrost/PermafrostMaterials.F90 ./Permafrost/Permafrost_Utils.F90 ./Permafrost/Permafrost_HTEQ.F90
    ./Permafrost/Permafrost_Darcy.F90 ./Permafrost/Permafrost_solute.F90 ./Permafrost/Permafrost_solid.F90
    SurfaceBoundaryEnthalpy.F90
    Calving.F90 FrontDisplacement.F90
    TwoMeshes.F90 ProjectCalving.F90 ComputeCalvingNormal.F90
    CalvingGeometry.F90 Calving3D.F90 Calving3D_lset.F90 CalvingGlacierAdvance3D.F90 CalvingRemesh.F90
    CalvingFrontAdvance3D.F90 Emergence.F90 SSAmask.F90
    GlaDSCoupledSolver.F90 GlaDSchannelSolver.F90 Flotation.F90
    BasalMelt3D.F90 CalvingHydroInterp.F90 HydroRestart.F90
    GMValid.F90 Scalar_OUTPUT_Glacier.F90 IcyMaskSolver.F90
    Weertman2Coulomb.F90)

SET(ElmerIce_SRC ${ElmerIce_SRC} ./Covarianceutils/CovarianceUtils.F90 ./Covarianceutils/BackgroundErrorCostSolver.F90 ./Covarianceutils/CovarianceVectorMultiplySolver.F90 ./Covarianceutils/GaussianSimulationSolver.F90)

IF(HAVE_ODEPack)
  SET(ElmerIce_SRC ${ElmerIce_SRC} PlumeSolver.F90 )
ENDIF()

IF(HAVE_MMG)
  SET(ElmerIce_SRC ${ElmerIce_SRC} CalvingRemeshMMG.F90 ) #MMG3DSolver.F90 <- defunct?
ENDIF()

### add ParMMG??

IF(HAVE_PARMMG)
  SET(ElmerIce_SRC ${ElmerIce_SRC} CalvingRemeshparMMG.F90 )
ENDIF()

IF(HAVE_XIOS)
  SET(ElmerIce_SRC ${ElmerIce_SRC} OutPutSolvers/XIOSOutputSolver.F90)
ENDIF()

IF(HAVE_NETCDF)
  SET(ElmerIce_SRC ${ElmerIce_SRC} UGridDataReader.F90)
ENDIF()

ADD_LIBRARY(ElmerIceSolvers SHARED ${ElmerIce_SRC})

# Library object
SET_TARGET_PROPERTIES(ElmerIceSolvers PROPERTIES PREFIX "")
SET_TARGET_PROPERTIES(ElmerIceSolvers PROPERTIES
    LINKER_LANGUAGE Fortran
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/fem/src/modules
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/fem/src/modules)
IF(NOT(WIN32))
    SET_TARGET_PROPERTIES(ElmerIceSolvers PROPERTIES
                          INSTALL_RPATH "${ELMERSOLVER_RPATH_STRING};${ELMER_SOLVER_HOME}/lib/")
    SET_TARGET_PROPERTIES(ElmerIceSolvers PROPERTIES
                          INSTALL_RPATH_USE_LINK_PATH TRUE)
ENDIF()
TARGET_LINK_LIBRARIES(ElmerIceSolvers Elmer::MPI_Fortran elmersolver ElmerIceUtils)

# XIOS depends on NetCDF and (optionally) HDF5 and has to be added first
IF(HAVE_XIOS)
  INCLUDE_DIRECTORIES(${XIOS_INCLUDE_DIR})
  TARGET_LINK_LIBRARIES(ElmerIceSolvers ${XIOS_LIBRARIES})
ENDIF()

# NetCDF depends on HDF5 and has to be added before HDF5
IF(HAVE_NETCDF)
  TARGET_LINK_LIBRARIES(ElmerIceSolvers ${NETCDF_LIBRARIES})
ENDIF()

IF(HAVE_HDF5)
  TARGET_LINK_LIBRARIES(ElmerIceSolvers ${PHDF5_LIBRARIES})
ENDIF()

# IF(HAVE_MMG)
#   TARGET_LINK_LIBRARIES(ElmerIceSolvers ${MMG_LIBRARY})
#   TARGET_LINK_LIBRARIES(ElmerIceSolvers ElmerIce_MeshAdapt3D)
# ENDIF()

IF(HAVE_PROJ)
  INCLUDE_DIRECTORIES(${PROJ_INCLUDE_DIR})
  INCLUDE_DIRECTORIES(${FORTRANGIS_INCLUDE_DIR})
  TARGET_LINK_LIBRARIES(ElmerIceSolvers ${PROJ_LIBRARY})
  TARGET_LINK_LIBRARIES(ElmerIceSolvers ${FORTRANGIS_LIBRARY})
ENDIF()

INSTALL(TARGETS ElmerIceSolvers LIBRARY DESTINATION "share/elmersolver/lib"
	    RUNTIME DESTINATION "share/elmersolver/lib")

IF(HAVE_NETCDF)
  ADD_SUBDIRECTORY(GridDataReader)
ENDIF()
IF(WITH_ScatteredDataInterpolator)
  ADD_SUBDIRECTORY(ScatteredDataInterpolator)
ENDIF()

=== elmerice/Tests/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.10)
PROJECT(ElmerIceTests Fortran C)

SET(ELMERGRID_BIN "${CMAKE_BINARY_DIR}/elmergrid/src/ElmerGrid")
IF(WITH_MPI)
  SET(ELMERSOLVER_BIN "${CMAKE_BINARY_DIR}/fem/src/ElmerSolver_mpi")
ELSE()
  SET(ELMERSOLVER_BIN "${CMAKE_BINARY_DIR}/fem/src/ElmerSolver")
ENDIF()
#SET(FINDNORM_BIN "${CMAKE_CURRENT_BINARY_DIR}/findnorm")

MACRO(SUBDIRLIST result curdir)
  FILE(GLOB children RELATIVE ${curdir} ${curdir}/*)
  SET(dirlist "")
  FOREACH(child ${children})
    IF(IS_DIRECTORY ${curdir}/${child})
        LIST(APPEND dirlist ${child})
    ENDIF()
  ENDFOREACH()
  SET(${result} ${dirlist})
ENDMACRO()

SUBDIRLIST(SUBDIRS ${CMAKE_CURRENT_SOURCE_DIR})

FOREACH(subdir ${SUBDIRS})
  IF(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${subdir}/CMakeLists.txt")
    ADD_SUBDIRECTORY(${subdir})
    LIST(APPEND TEST_SUBDIRS ${subdir})
  ENDIF(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${subdir}/CMakeLists.txt")
ENDFOREACH()

#SET(INSTALL_OLD_TESTS FALSE CACHE BOOL "(deprecated) Install old test system under build directory.")

FOREACH(_subdir ${TEST_SUBDIRS})
  FILE(GLOB files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/${_subdir}/*")
  FOREACH(_file ${files})
    IF(NOT(${_file} MATCHES "CMakeLists.txt$"))
      IF(NOT(${_file} MATCHES "runTest.cmake$"))
        LIST(APPEND ELMERICE_TEST_FILES ${_file})
      ENDIF()
    ENDIF()
  ENDFOREACH()
ENDFOREACH()

# ElmerTests_package target
SET(ELMERICE_TESTS_PACKAGE_FILENAME "elmerice-tests-${ELMER_FEM_REVISION}.tar.gz" CACHE STRING "Filename of test package")
MARK_AS_ADVANCED(ELMERICE_TESTS_PACKAGE_FILENAME)

ADD_CUSTOM_TARGET(ElmerIceTests
  "${CMAKE_COMMAND}" "-E" "make_directory" "${CMAKE_BINARY_DIR}/elmerice-tests")
ADD_CUSTOM_TARGET(ElmerIceTests_package
  DEPENDS ElmerIceTests
  COMMAND "${CMAKE_COMMAND}" "-E" "tar" "cvfz" "${ELMERICE_TESTS_PACKAGE_FILENAME}" "elmerice-tests"
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

# Copy the tests in a cross platform compliant manner
FOREACH(_file ${ELMERICE_TEST_FILES})
  IF(NOT(IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/${_file}))
    ADD_CUSTOM_COMMAND(TARGET ElmerIceTests
      POST_BUILD
      COMMAND "${CMAKE_COMMAND}" "-E" "copy"
      "${CMAKE_CURRENT_SOURCE_DIR}/${_file}"
      "${CMAKE_BINARY_DIR}/elmerice-tests/${_file}")
  ELSE()
    ADD_CUSTOM_COMMAND(TARGET ElmerIceTests
      POST_BUILD
      COMMAND "${CMAKE_COMMAND}" "-E" "copy_directory"
      "${CMAKE_CURRENT_SOURCE_DIR}/${_file}"
      "${CMAKE_BINARY_DIR}/elmerice-tests/${_file}")
  ENDIF()
ENDFOREACH()

	

#IF(NOT(CMAKE_BUILD_TYPE MATCHES "Rel"))
#INSTALL(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/. #
#		  DESTINATION ${CMAKE_BINARY_DIR}/elmericetests#
#		  FILES_MATCHING REGEX 
#		  ".+\\.(f90|F90|sif|mif|grd|eg|msh|good|dat|pos|result|in2d|best0|txt)|HB|Makefile|TEST\\.RESULT|ELMERSOLVER_STARTINFO|mesh\\.*|DATA|PROG")
#
#INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/Compare.f90
#	      ${CMAKE_CURRENT_SOURCE_DIR}/ElmerIceSolver_test_how-to.txt
#	     	  DESTINATION ${CMAKE_BINARY_DIR}/elmericetests)
#INSTALL(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/runTest.sh
#		  DESTINATION ${CMAKE_BINARY_DIR}/elmericetests)
#ENDIF()

=== fem/src/CMakeLists.txt ===
# For the installer process we need a single directory
# where we put all module files
SET(CMAKE_Fortran_MODULE_DIRECTORY
  ${PROJECT_BINARY_DIR}/fmodules CACHE PATH "Directory for Fortran modules")

ADD_SUBDIRECTORY(binio)
ADD_SUBDIRECTORY(modules)
ADD_SUBDIRECTORY(view3d)
ADD_SUBDIRECTORY(viewaxis)

IF(WITH_MPI)
  SET(ELMERSOLVER_OUTPUT_NAME "ElmerSolver_mpi") 
ELSE()
  SET(ELMERSOLVER_OUTPUT_NAME "ElmerSolver")
ENDIF()

SET(prefix "${CMAKE_INSTALL_PREFIX}")

SET(solverlib_SOURCES AddrFunc.F90 NavierStokes.F90 NavierStokesGeneral.F90
  NavierStokesCylindrical.F90 Lists.F90
  DiffuseConvectiveAnisotropic.F90 LoadMod.F90
  DiffuseConvectiveGeneralAnisotropic.F90 PElementMaps.F90
  PElementBase.F90 ElementDescription.F90 Integration.F90 ListMatrixArray.F90
  ModelDescription.F90 GeneralUtils.F90 Stress.F90 StressGeneral.F90
  LinearAlgebra.F90 CoordinateSystems.F90 ListMatrix.F90 CRSMatrix.F90
  BandMatrix.F90 BandwidthOptimize.F90 BlockSolve.F90
  MaterialModels.F90 DirectSolve.F90 IterSolve.F90
  IterativeMethods.F90 TimeIntegrate.F90 Types.F90 SolveBand.F90
  ElementUtils.F90 Radiation.F90 fft.c Load.c Differentials.F90
  FreeSurface.F90 
  Walls.F90 SolverUtils.F90 SolveSBand.F90 CPUTime.c Interpolation.F90
  MainUtils.F90 Adaptive.F90 EigenSolve.F90 HashTable.F90
  MeshUtils.F90 SaveUtils.F90 SParIterGlobals.F90 SParIterComm.F90
  SParIterPrecond.F90 SParIterSolver.F90 Messages.F90 Multigrid.F90
  Smoothers.F90 ClusteringMethods.F90 ParallelUtils.F90
  ParallelEigenSolve.F90 solve_cmplx.F90 solve_real.F90 MGPrec.F90
  DefUtils.F90 MeshPartition.F90 MeshRemeshing.F90 CutFEMUtils.F90
  RadiationFactors.F90 f_stubs.c
  ExchangeCorrelations.F90 SolveHypre.c amgx.c rocalution.cpp SolverActivate_x.F90
  SolveSuperLU.c
  umf4_f77wrapper.c VankaCreate.F90 ParticleUtils.F90 Feti.F90
  cholmod.c InterpolateMeshToMesh.F90 InterpVarToVar.F90
  LinearForms.F90 H1Basis.F90 CircuitUtils.F90 BackwardError.F90
  ElmerSolver.F90 MagnetoDynamicsUtils.F90 LumpingUtils.F90 
  ZirkaHysteresis.F90 SolidMechanicsUtils.F90 MatrixAssembly.F90 
  OptimizationUtils.F90 MeshGenerate.F90)

#SET_PROPERTY(SOURCE MaxwellAxiS.F90 PROPERTY
#	COMPILE_DEFINITIONS FULL_INDUCTION)

IF(WITH_EXTOPTIM)
  LIST(APPEND solverlib_SOURCES minpack.F90 minpack_kinds.F90
  PowellOptBobyqa.F90 PowellOptNewuoa.F90)
  SET(HAVE_EXTOPTIM TRUE)
ENDIF() 
      
IF(WITH_LUA)
  INCLUDE_DIRECTORIES(${LUA_INCLUDE_DIR})
  LIST(APPEND solverlib_SOURCES Lua.F90 elmer_lua_iface.c)
  INSTALL(DIRECTORY lua-scripts DESTINATION share/elmersolver/
    PATTERN lua-scripts/*.lua)
  FILE(GLOB DEFAULT_LUA_SCRIPTS "lua-scripts/*.lua")
  FILE(COPY ${DEFAULT_LUA_SCRIPTS} DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/share/elmersolver/lua-scripts/)
ELSE()
  LIST(APPEND solverlib_SOURCES Lua.F90)
ENDIF()

IF(HAVE_FETI4I)
  LIST(APPEND solverlib_SOURCES ${FETI4I_INTERFACE_SOURCE})
ENDIF()

#FILE(GLOB SRC_FILES *.src)
#FOREACH(FNAME ${SRC_FILES})
#GET_FILENAME_COMPONENT(BASENAME ${FNAME} NAME_WE)
#ADD_CUSTOM_COMMAND(
  #OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${BASENAME}.F90
  #COMMAND ${CMAKE_COMMAND} -E copy ${FNAME}
    #${CMAKE_CURRENT_BINARY_DIR}/${BASENAME}.F90
  #DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${BASENAME}.src
  #)
#ENDFOREACH()

INCLUDE_DIRECTORIES("${CMAKE_BINARY_DIR}/fem/src")
INCLUDE_DIRECTORIES("${CMAKE_SOURCE_DIR}/fhutiter/src")
INCLUDE_DIRECTORIES("${CMAKE_CURRENT_BINARY_DIR}/binio")
INCLUDE_DIRECTORIES("${PROJECT_BINARY_DIR}/fhutiter/src")

# Extract additional compile flags
GET_DIRECTORY_PROPERTY( ELMER_CDEFS COMPILE_DEFINITIONS )
FOREACH( d ${ELMER_CDEFS} )
	 SET(ELMER_F90FLAGS "${ELMER_F90FLAGS} -D${d}")
ENDFOREACH()


# Extract compile flags arising from build type
IF(CMAKE_BUILD_TYPE)
  STRING(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE_UPCASE)
  SET(ELMER_F90FLAGS "${ELMER_F90FLAGS} ${CMAKE_Fortran_FLAGS_${CMAKE_BUILD_TYPE_UPCASE}}")
  MARK_AS_ADVANCED(CMAKE_BUILD_TYPE_UPCASE)
ENDIF(CMAKE_BUILD_TYPE)

# Output elmerf90 and elmerld
SET(HAVE_ELMERICE "FALSE")
IF(WITH_ElmerIce)
  SET(HAVE_ELMERICE "TRUE")
ENDIF()

IF(WIN32)
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/elmerf90.bat.in.cmake
	  ${CMAKE_CURRENT_BINARY_DIR}/elmerf90.bat)
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/elmerld.bat.in.cmake
	  ${CMAKE_CURRENT_BINARY_DIR}/elmerld.bat)
ENDIF()

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/elmerf90-nosh.in.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/elmerf90-nosh)
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/elmerf90.in.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/elmerf90)
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/elmerld.in.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/elmerld)

# Create pkg-config file if requested and place it under ${PKGCONFIG_PC_PATH}
# Defaults: PKGCONFIG_PC_PATH = ${CMAKE_INSTALL_PREFIX}/share/pkgconfig
IF(CREATE_PKGCONFIG_FILE)
  SET(PKGCONFIG_PC_PATH "${CMAKE_INSTALL_PREFIX}/share/pkgconfig" 
    CACHE PATH "Path where to install elmer pkg-config file")
  CONFIGURE_FILE(elmer.pc.cmake elmer.pc @ONLY)
  INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/elmer.pc 
    DESTINATION ${PKGCONFIG_PC_PATH})
ENDIF(CREATE_PKGCONFIG_FILE)

# Copy elements.def and SOLVER.KEYWORDS (to enable testing)
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/elements.def 
  ${CMAKE_CURRENT_BINARY_DIR}/elements.def COPYONLY)
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/SOLVER.KEYWORDS
  ${CMAKE_CURRENT_BINARY_DIR}/SOLVER.KEYWORDS COPYONLY)

IF (NOT MPI_FOUND)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/mpif_stub.h ${CMAKE_CURRENT_BINARY_DIR}/mpif.h COPYONLY)
  # add path to stub header to dummy import target
  target_include_directories(Elmer::MPI_Fortran INTERFACE ${CMAKE_CURRENT_BINARY_DIR})
ENDIF()

ADD_LIBRARY(mpi_stubs SHARED mpif_stubs.F90)
ADD_LIBRARY(elmersolver SHARED ${solverlib_SOURCES})
SET_TARGET_PROPERTIES(mpi_stubs
                      PROPERTIES LINKER_LANGUAGE Fortran)
SET_TARGET_PROPERTIES(elmersolver
                      PROPERTIES LINKER_LANGUAGE Fortran)

#We want MMG & Zoltan in the RPATH (if found), but given how many other 
#components use ELMERSOLVER_RPATH_STRING, it seemed best to make
#a local copy just for ElmerSolver and libelmersolver
SET(ELMERSOLVER_RPATH_STRING_MOD "${ELMERSOLVER_RPATH_STRING}")
IF(HAVE_MMG)
  TARGET_LINK_LIBRARIES(elmersolver ${MMG_LIBRARY})
  SET(ELMERSOLVER_RPATH_STRING_MOD "${ELMERSOLVER_RPATH_STRING_MOD}:${MMG_LIBDIR}")
  SET(ELMERLIB_RPATH_STRING "${ELMERLIB_RPATH_STRING}:${MMG_LIBDIR}")
  #TODO - add to RPath
ENDIF()

IF(HAVE_PARMMG)
  TARGET_LINK_LIBRARIES(elmersolver ${PARMMG_LIBRARY})
  SET(ELMERSOLVER_RPATH_STRING_MOD "${ELMERSOLVER_RPATH_STRING_MOD}:${PARMMG_LIBDIR}")
  SET(ELMERLIB_RPATH_STRING "${ELMERLIB_RPATH_STRING}:${PARMMG_LIBDIR}")
  #TODO - add to RPath
ENDIF()
  
IF(HAVE_ZOLTAN)
  IF(USE_SYSTEM_ZOLTAN)
    TARGET_LINK_LIBRARIES(elmersolver Zoltan::zoltan)
  ELSE()
    ADD_DEPENDENCIES(elmersolver zoltan)
    TARGET_LINK_LIBRARIES(elmersolver ${ZOLTAN_LIBRARY})
  ENDIF()
  IF(Zoltan_ENABLE_ParMETIS)
    TARGET_LINK_LIBRARIES(elmersolver ${ParMetis_LIBRARIES})
  ENDIF()
  # SET(ELMERSOLVER_RPATH_STRING_MOD "${ELMERSOLVER_RPATH_STRING_MOD}/:${ZOLTAN_LIBDIR}")
  # SET(ELMERLIB_RPATH_STRING "${ELMERLIB_RPATH_STRING}/:${ZOLTAN_LIBDIR}")
ENDIF()

# ElmerSolver libraries
SET(ELMERSOLVER_LIBRARIES matc fhuti binio arpack)

IF(UMFPACK_FOUND)
  # external implementation of UMFPACK
  LIST(APPEND ELMERSOLVER_LIBRARIES ${UMFPACK_LIBRARIES})

  TARGET_INCLUDE_DIRECTORIES(elmersolver PRIVATE ${UMFPACK_INCLUDE_DIR})
  #LIST(APPEND ELMERSOLVER_LIBRARIES ${UMFPACK_LIBRARIES})
  #TARGET_LINK_LIBRARIES(elmersolver "${UMFPACK_LIBRARIES}")
ELSE()
  # bundled UMFPACK
  LIST(APPEND ELMERSOLVER_LIBRARIES umfpack amd)
  TARGET_INCLUDE_DIRECTORIES(elmersolver PRIVATE ${PROJECT_SOURCE_DIR}/umfpack/src/umfpack/include)
ENDIF()

LIST(APPEND ELMERSOLVER_LIBRARIES
  ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES}
  ${CMAKE_DL_LIBS})

IF(WITH_LUA)
  LIST(APPEND ELMERSOLVER_LIBRARIES ${LUA_LIBRARIES})
ENDIF()


ADD_EXECUTABLE(Solver_TGT Solver.F90)
SET_TARGET_PROPERTIES(Solver_TGT PROPERTIES OUTPUT_NAME "${ELMERSOLVER_OUTPUT_NAME}")

IF(NOT(WIN32))
  MESSAGE(STATUS " ELMERSOLVER_RPATH_STRING_MOD " ${ELMERSOLVER_RPATH_STRING_MOD})
  MESSAGE(STATUS " ELMERLIB_RPATH_STRING " ${ELMERLIB_RPATH_STRING})

   SET_TARGET_PROPERTIES(Solver_TGT PROPERTIES INSTALL_RPATH "${ELMERSOLVER_RPATH_STRING_MOD}")
   SET_TARGET_PROPERTIES(elmersolver PROPERTIES INSTALL_RPATH "${ELMERLIB_RPATH_STRING}")
ENDIF()

IF(NOT(WITH_MPI))
  TARGET_LINK_LIBRARIES(elmersolver mpi_stubs ${ELMERSOLVER_LIBRARIES})
  TARGET_LINK_LIBRARIES(Solver_TGT elmersolver)
ENDIF()

IF(WITH_MPI)
  #ADD_LIBRARY(elmersolver_mpi SHARED ${solverlib_SOURCES})

  # Add parpack and possibly others
  IF(Mumps_LIBRARIES)
    INCLUDE_DIRECTORIES(${Mumps_INCLUDE_DIR})
    # Link to SCALAPACK implicitly
    LIST(APPEND ELMERSOLVER_LIBRARIES ${Mumps_LIBRARIES})
  ELSEIF(MKL_CPARDISO_FOUND)
    # Mumps includes SCALAPACK, but it is needed with CPARDISO
    LIST(APPEND ELMERSOLVER_LIBRARIES ${SCALAPACK_LIBRARIES})
  ENDIF()

  IF(Hypre_LIBRARIES)
    LIST(APPEND ELMERSOLVER_LIBRARIES Elmer::MPI_C ${Hypre_LIBRARIES})
  ENDIF()

  IF(XIOS_LIBRARIES)
    # XIOS depends on NetCDF (mandatory) and HDF5 (optional), since linking order matters, XIOS must be added before the other two
    LIST(APPEND ELMERSOLVER_LIBRARIES ${XIOS_LIBRARIES})
  ENDIF()

  IF(NETCDF_LIBRARIES)
    LIST(APPEND ELMERSOLVER_LIBRARIES ${NETCDF_LIBRARIES})
    IF(PHDF5_LIBRARIES)
      LIST(APPEND ELMERSOLVER_LIBRARIES ${PHDF5_LIBRARIES})
    ENDIF()
  ENDIF()

  IF(FETI4I_LIBRARIES)
    LIST(APPEND ELMERSOLVER_LIBRARIES ${FETI4I_LIBRARIES})
  ENDIF()

  # Executable
  TARGET_LINK_LIBRARIES(Solver_TGT Elmer::MPI_Fortran elmersolver ${ELMERSOLVER_LIBRARIES})

  # Library object
  TARGET_LINK_LIBRARIES(elmersolver Elmer::MPI_Fortran ${ELMERSOLVER_LIBRARIES} parpack)

  SET(SERIAL_SOLVER_FILEPATH "${CMAKE_INSTALL_PREFIX}/bin/ElmerSolver")
  SET(MPI_SOLVER_FILEPATH "${CMAKE_INSTALL_PREFIX}/bin/${ELMERSOLVER_OUTPUT_NAME}")
ENDIF()

IF(MPI_Fortran_HAVE_F90_MODULE)
  TARGET_COMPILE_DEFINITIONS(elmersolver PRIVATE ELMER_HAVE_MPI_MODULE)
ELSE()
  # Either the header from an actual MPI implementation or the replacement stub
  TARGET_COMPILE_DEFINITIONS(elmersolver PRIVATE ELMER_HAVE_MPIF_HEADER)
ENDIF()
IF(WITH_ROCALUTION)
  TARGET_LINK_LIBRARIES(elmersolver roc::rocalution)
ENDIF()  

IF(WITH_AMGX)
  TARGET_LINK_LIBRARIES(elmersolver Elmer::MPI_C "${AMGX_LIBRARY};${CUDA_LIBRARIES}")
  TARGET_INCLUDE_DIRECTORIES(elmersolver PRIVATE "${CUDA_INCLUDE_DIRS}")
ENDIF()

IF (WITH_CHOLMOD)
  SET(CURR_CFLAGS "-DHAVE_CHOLMOD")
  TARGET_INCLUDE_DIRECTORIES(elmersolver PRIVATE "${CHOLMOD_INCLUDE_DIR};${SPQR_INCLUDE_DIR}")
  TARGET_LINK_LIBRARIES(elmersolver "${CHOLMOD_LIBRARIES};${SPQR_LIBRARIES}")
ENDIF()    

# elmersolver -library
#TARGET_LINK_LIBRARIES(elmersolver ${ELMERSOLVER_LIBRARIES})

## ElmerSolver serial
#IF(NOT(NO_SERIAL_BINARY))
  #TARGET_LINK_LIBRARIES(elmersolver mpi_stubs ${ELMERSOLVER_LIBRARIES})
  #TARGET_LINK_LIBRARIES(ElmerSolver elmersolver)
#ENDIF()

# ElmerSolver
#ADD_EXECUTABLE(ElmerSolver Solver.F90)
#TARGET_LINK_LIBRARIES(ElmerSolver ${ELMERSOLVER_LIBRARIES} 
                                  #mpi_stubs)

# ViewFactors
ADD_EXECUTABLE(ViewFactors ViewFactors.F90)
SET_TARGET_PROPERTIES(ViewFactors PROPERTIES LINKER_LANGUAGE Fortran)
# TARGET_INCLUDE_DIRECTORIES(ViewFactors PUBLIC ${CMAKE_BINARY_DIR}/fem/src/view3d)
# TARGET_INCLUDE_DIRECTORIES(ViewFactors PUBLIC ${CMAKE_BINARY_DIR}/fem/src/viewfactors)
# FIND_LIBRARY(VIEW3D_LIBRARIES PATHS ${CMAKE_CURRENT_BINARY_DIR}/view3d)
# FIND_LIBRARY(VIEWAXIS_LIBRARIES PATHS ${CMAKE_CURRENT_BINARY_DIR}/viewaxis)
TARGET_LINK_LIBRARIES(ViewFactors view3d viewaxis elmersolver)
INSTALL(TARGETS ViewFactors RUNTIME DESTINATION "bin")

IF(NOT(WIN32))
  SET_TARGET_PROPERTIES(ViewFactors PROPERTIES INSTALL_RPATH "${ELMERSOLVER_RPATH_STRING}")
ENDIF()

# Radiators
ADD_EXECUTABLE(Radiators Radiators.F90)
SET_TARGET_PROPERTIES(Radiators PROPERTIES LINKER_LANGUAGE Fortran)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=elmerfem
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         $([[ "${CARCH}" == "aarch64" ]] || echo "${MINGW_PACKAGE_PREFIX}-${_realname}-mpi"))
pkgver=26.1
pkgrel=1
pkgdesc="Finite element software for multiphysical problems (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64')
url='https://www.elmerfem.org/'
msys2_repository_url="https://github.com/ElmerCSC/elmerfem"
msys2_references=(
  'aur: elmerfem'
)
license=('spdx:GPL-2.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-arpack"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-mumps")
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openblas"
         "${MINGW_PACKAGE_PREFIX}-parpack"
         "${MINGW_PACKAGE_PREFIX}-opencascade"
         "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
         "${MINGW_PACKAGE_PREFIX}-qwt-qt6"
         "${MINGW_PACKAGE_PREFIX}-suitesparse"
         "${MINGW_PACKAGE_PREFIX}-unixodbc"
         "${MINGW_PACKAGE_PREFIX}-vtk")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-adios2"
             "${MINGW_PACKAGE_PREFIX}-anari-sdk"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-cgns"
             "${MINGW_PACKAGE_PREFIX}-cli11"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-fast_float"
             "${MINGW_PACKAGE_PREFIX}-ffmpeg"
             "${MINGW_PACKAGE_PREFIX}-gl2ps"
             "${MINGW_PACKAGE_PREFIX}-liblas"
             "${MINGW_PACKAGE_PREFIX}-libmariadbclient"
             $([[ "${CARCH}" == "aarch64" ]] || echo "${MINGW_PACKAGE_PREFIX}-msmpi")
             "${MINGW_PACKAGE_PREFIX}-netcdf"
             "${MINGW_PACKAGE_PREFIX}-openslide"
             "${MINGW_PACKAGE_PREFIX}-openvdb"
             "${MINGW_PACKAGE_PREFIX}-pdal"
             "${MINGW_PACKAGE_PREFIX}-scnlib"
             "${MINGW_PACKAGE_PREFIX}-utf8cpp")
source=("${_realname}-${pkgver}.tar.gz::https://github.com/ElmerCSC/elmerfem/archive/refs/tags/release-${pkgver}.tar.gz"
        "001-Set-locale-C-before-formatting-strings-in-MATC.patch")
sha256sums=('8a7371d92d820331b71428d0219119a68a514eca29848d4c3a420e701677cf2f'
            'f4c2fb269eed44e331af1752d830193c6410ca665813140c44bea0f4e8d78e84')

_apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -p1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd ${_realname}-release-${pkgver}

  _apply_patch_with_msg \
    001-Set-locale-C-before-formatting-strings-in-MATC.patch
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  declare -a _common_config
  _common_config=("-DBUILD_SHARED_LIBS=ON"
                  "-DCPACK_BUNDLE_EXTRA_WINDOWS_DLLS=OFF"
                  "-DBLA_VENDOR=OpenBLAS"
                  "-DEXTERNAL_ARPACK=ON"
                  "-DEXTERNAL_PARPACK=ON"
                  "-DEXTERNAL_UMFPACK=ON"
                  "-DWITH_ELMERGUI=ON"
                  "-DWITH_LUA=ON"
                  "-DWITH_MATC=ON"
                  "-DWITH_OCC=ON"
                  "-DWITH_OpenMP=ON"
                  "-DWITH_PARAVIEW=ON"
                  "-DWITH_QT6=ON"
                  "-DWITH_VTK=ON"
                  "-DWITH_Zoltan=OFF"
                  "-DCREATE_PKGCONFIG_FILE=ON"
                  "-DParMetis_LIBRARIES=$(pkg-config --libs parmetis)"
                  "-DParMetis_INCLUDE_DIR=$(pkg-config --cflags parmetis)")

  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    export FFLAGS="-I${MINGW_PREFIX}/include"
    _common_config+=("-DWITH_Mumps=OFF")
  else
    _common_config+=("-DWITH_Mumps=ON")
    _common_config+=("-DMumps_LIBRARIES=$(pkg-config --libs mumps-dmo mumps-zmo mumps-smo mumps-cmo)")
    _common_config+=("-DMumps_INCLUDE_DIR=$(pkg-config --variable=includedir mumps-dmo mumps-zmo mumps-smo mumps-cmo)")
  fi

  msg2 "Without MPI"
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  CFLAGS+=" -Wno-error=incompatible-pointer-types" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -Wno-dev \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      "${_common_config[@]}" \
      -DWITH_ElmerIce=OFF \
      -DWITH_MPI=OFF \
      ../${_realname}-release-${pkgver}

  "${MINGW_PREFIX}"/bin/cmake.exe --build .

  if [[ "${CARCH}" != "aarch64" ]]; then
    msg2 "With MPI"
    mkdir -p "${srcdir}/build-${MSYSTEM}-mpi" && cd "${srcdir}/build-${MSYSTEM}-mpi"

    CFLAGS+=" -Wno-error=incompatible-pointer-types" \
    MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
      "${MINGW_PREFIX}"/bin/cmake.exe \
        -Wno-dev \
        -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
        "${_extra_config[@]}" \
        "${_common_config[@]}" \
        -DWITH_ElmerIce=ON \
        -DWITH_MPI=ON \
        ../${_realname}-release-${pkgver}

    "${MINGW_PREFIX}"/bin/cmake.exe --build .
  fi
}

check() {
  msg2 "Without MPI"
  cd "${srcdir}/build-${MSYSTEM}"
  ${MINGW_PREFIX}/bin/ctest . -LE slow || true

  if [[ "${CARCH}" != "aarch64" ]]; then
    msg2 "With MPI"
    cd "${srcdir}/build-${MSYSTEM}-mpi"
    # This is the default installation location for Microsoft MPI.
    # It might need to be adjusted dependent on the system where the tests are run.
    MSMPI_BIN="/c/Program Files/Microsoft MPI/Bin"
    #: ${MSMPI_BIN:="/c/Program Files/Microsoft MPI/Bin"}

    ${MINGW_PREFIX}/bin/cmake \
      -DMPI_TEST_MAXPROC=$(nproc) \
      -DMPIEXEC_EXECUTABLE="${MSMPI_BIN}/mpiexec.exe" \
      ../${_realname}-release-${pkgver}
    ${MINGW_PREFIX}/bin/cmake --build .
    ${MINGW_PREFIX}/bin/ctest . -LE slow || true
  fi
}

package_elmerfem() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .

  WIN_PREFIX=$(cygpath -wm ${MINGW_PREFIX})
  for _f in elmerf90 elmerld; do
    sed -e "s|${WIN_PREFIX}|${MINGW_PREFIX}|g" -i "${pkgdir}${MINGW_PREFIX}"/bin/${_f}
  done
  sed -e "s|${WIN_PREFIX}|$\{prefix}|g" -i "${pkgdir}${MINGW_PREFIX}"/share/pkgconfig/elmer.pc

  rm "${pkgdir}${MINGW_PREFIX}"/bin/*.bat

  install -Dm644 "${srcdir}/${_realname}-release-${pkgver}/license_texts/LICENSES_GPL.txt" -t "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}"
}

package_elmerfem-mpi() {
  pkgdesc="Finite element software for multiphysical problems with MPI (mingw-w64)"
  conflicts=("${MINGW_PACKAGE_PREFIX}-${_realname}")

  cd "${srcdir}/build-${MSYSTEM}-mpi"

  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .

  WIN_PREFIX=$(cygpath -wm ${MINGW_PREFIX})
  for _f in elmerf90 elmerld; do
    sed -e "s|${WIN_PREFIX}|${MINGW_PREFIX}|g" -i "${pkgdir}${MINGW_PREFIX}"/bin/${_f}
  done
  sed -e "s|${WIN_PREFIX}|$\{prefix}|g" -i "${pkgdir}${MINGW_PREFIX}"/share/pkgconfig/elmer.pc

  rm "${pkgdir}${MINGW_PREFIX}"/bin/*.bat

  install -Dm644 "${srcdir}/${_realname}-release-${pkgver}/license_texts/LICENSES_GPL.txt" -t "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}"
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
